/// <reference types="react" />
import { FieldValues, UseFieldArrayAppend, UseFieldArrayRemove, UseFormGetValues } from "react-hook-form";
type FieldArrayType<T extends string> = {
    append: UseFieldArrayAppend<FieldValues, T>;
    remove: UseFieldArrayRemove;
    fields: Record<"id", string>[];
};
type FormContextType = {
    instanceRef: React.MutableRefObject<HTMLInputElement | undefined>;
    getValues: UseFormGetValues<FieldValues>;
};
export default function useDynamicFields<T extends FieldValues>(formContext: FormContextType, fieldArray: FieldArrayType<keyof FieldValues>, fieldName: T): {
    handleKeyDownEnter: (e: React.KeyboardEvent<HTMLInputElement>, handleFieldCallbacks?: (() => void)[]) => void;
    checkFieldValueDuplicated: (alertMessage?: string) => void;
    lockDynamicField: () => void;
    appendDynamicField: (fieldLimit?: number) => void;
    deleteDynamicField: <T_1 extends HTMLElement>(e: import("react").MouseEvent<T_1, MouseEvent>, idx: number, appendNewFiled?: boolean) => void;
    activeField: () => void;
    clickOutside: (e: Event, ignoredTarget?: HTMLElement, handleFieldCallbacks?: (() => void)[]) => void;
};
export {};
