/// <reference types="react" />
import { FieldValues, Path, UseFormRegister } from "react-hook-form";
import { RegisterOption } from "../types/common";
export declare function useRegisterWithRef<TFieldValues extends FieldValues>(register: UseFormRegister<TFieldValues>): {
    registerWithRef: (fieldName: Path<TFieldValues>, registerOptions: RegisterOption<TFieldValues>) => {
        ref: (instance: HTMLInputElement | null) => void;
        onChange: import("react-hook-form").ChangeHandler;
        onBlur: import("react-hook-form").ChangeHandler;
        name: Path<TFieldValues>;
        min?: string | number | undefined;
        max?: string | number | undefined;
        maxLength?: number | undefined;
        minLength?: number | undefined;
        pattern?: string | undefined;
        required?: boolean | undefined;
        disabled?: boolean | undefined;
    };
    instanceRef: import("react").MutableRefObject<HTMLInputElement | undefined>;
};
