var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { useRef } from "react";
export function useRegisterWithRef(register) {
    var instanceRef = useRef();
    function createRegister(fieldName, registerOptions) {
        return register(fieldName, registerOptions);
    }
    function registerWithRef(fieldName, registerOptions) {
        var register = createRegister(fieldName, registerOptions);
        var ref = function (instance) {
            if (!instance)
                return;
            instanceRef.current = instance;
            register.ref(instance);
        };
        return __assign(__assign({}, register), { ref: ref });
    }
    return { registerWithRef: registerWithRef, instanceRef: instanceRef };
}
